"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _2 = require("./..");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * @category containers
 * @component list-item
 * @variations collab-ui-react
 */
var ListItemMeeting =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(ListItemMeeting, _React$PureComponent);

  function ListItemMeeting() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this, _this.state = {
      id: _lodash.default.uniqueId(_this.props.id && _this.props.id + "-" || 'cui-list-item__meeting-'),
      isOpen: false,
      offset: -10
    }, _this.handleAnchorClick = function (e) {
      var anchorOnClick = _this.props.anchorOnClick;
      e.persist();
      anchorOnClick && anchorOnClick(e);
      e.stopPropagation();
    }, _this.handleAnchorKeyDown = function (e) {
      var anchorOnClick = _this.props.anchorOnClick;

      if (e.which === 32 || e.which === 13 || e.charCode === 32 || e.charCode === 13) {
        _this.handleAnchorClick(e);
      } else {
        e.stopPropagation();
      }
    }, _this.handleClick = function (e) {
      var onClick = _this.props.onClick;
      var isOpen = _this.state.isOpen;

      _this.setState(function () {
        onClick && onClick(e);
        return {
          offset: -(_reactDom.default.findDOMNode(_this.container).getBoundingClientRect().width * .4),
          isOpen: !isOpen
        };
      });
    }, _this.handleClickAway = function () {
      _this.setState({
        isOpen: false
      });
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = ListItemMeeting.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        anchorLabel = _this$props.anchorLabel,
        anchorOnClick = _this$props.anchorOnClick,
        childrenRight = _this$props.childrenRight,
        className = _this$props.className,
        inProgress = _this$props.inProgress,
        isAllDay = _this$props.isAllDay,
        isCompleted = _this$props.isCompleted,
        isRecurring = _this$props.isRecurring,
        header = _this$props.header,
        onClick = _this$props.onClick,
        popoverContent = _this$props.popoverContent,
        time = _this$props.time,
        title = _this$props.title,
        props = _objectWithoutProperties(_this$props, ["anchorLabel", "anchorOnClick", "childrenRight", "className", "inProgress", "isAllDay", "isCompleted", "isRecurring", "header", "onClick", "popoverContent", "time", "title"]);

    var _this$state = this.state,
        id = _this$state.id,
        isOpen = _this$state.isOpen,
        offset = _this$state.offset;
    var getTitle = !title ? header : title;

    var getTime = function getTime() {
      if (isAllDay) {
        return _react.default.createElement("span", null, "All day");
      } else if (time.start) {
        return [_react.default.createElement("span", {
          key: "time-0"
        }, time.start), time.end && _react.default.createElement("span", {
          key: "time-1"
        }, time.end)];
      }
    };

    var children = [_react.default.createElement(_2.ListItemSection, {
      key: "child-0",
      position: "left"
    }, inProgress && _react.default.createElement("span", {
      className: "cui-list-item-meeting__progress-line"
    }), getTime()), _react.default.createElement(_2.ListItemSection, {
      key: "child-1",
      position: "center"
    }, _react.default.createElement("div", {
      className: "cui-list-item__header"
    }, _react.default.createElement("span", null, header), isRecurring && _react.default.createElement(_2.Icon, {
      name: "recurring_12"
    }), _react.default.createElement(_2.EventOverlay, {
      key: "child-3",
      direction: "right-center",
      close: this.handleClickAway,
      isOpen: isOpen,
      children: popoverContent,
      targetOffset: {
        horizontal: offset
      },
      showArrow: true,
      anchorNode: this.container
    })), _react.default.createElement("div", {
      className: "cui-list-item__space-link"
    }, anchorLabel && anchorOnClick && _react.default.createElement("a", {
      onClick: this.handleAnchorClick,
      onKeyDown: this.handleAnchorKeyDown,
      title: anchorLabel
    }, anchorLabel))), _react.default.createElement(_2.ListItemSection, {
      key: "child-2",
      position: "right"
    }, childrenRight)];
    return _react.default.createElement(_2.ListItem, _extends({
      className: 'cui-list-item-meeting' + ("" + (isCompleted && ' cui-list-item-meeting--completed' || '')) + ("" + (className && " " + className || '')),
      id: id,
      title: getTitle,
      type: 60,
      ref: function ref(_ref) {
        return _this2.container = _ref;
      },
      onClick: this.handleClick
    }, props), children);
  };

  return ListItemMeeting;
}(_react.default.PureComponent);

exports.default = ListItemMeeting;
ListItemMeeting.displayName = 'ListItemMeeting';
ListItemMeeting.defaultProps = {
  anchorOnClick: null,
  anchorLabel: '',
  childrenRight: null,
  className: '',
  header: '',
  id: '',
  inProgress: false,
  isAllDay: false,
  isRecurring: false,
  isCompleted: false,
  onClick: null,
  popoverContent: null,
  time: {
    start: '',
    end: ''
  },
  title: ''
};
ListItemMeeting.propTypes = {
  /** ListItemMeeting Anchor string */
  anchorLabel: _propTypes.default.string,

  /** ListItemMeeting Anchor Click */
  anchorOnClick: _propTypes.default.func,

  /** Children for right section */
  childrenRight: _propTypes.default.node,

  /** HTML Class for associated input */
  className: _propTypes.default.string,

  /** ListItem header */
  header: _propTypes.default.string.isRequired,

  /** HTML ID for associated input */
  id: _propTypes.default.string,

  /** ListItemMeeting Boolean */
  inProgress: _propTypes.default.bool,

  /** ListItemMeeting Boolean */
  isAllDay: _propTypes.default.bool,

  /** ListItemMeeting Boolean */
  isRecurring: _propTypes.default.bool,

  /** ListItemMeeting Boolean */
  isCompleted: _propTypes.default.bool,

  /** ListItemMeeting OnClick */
  onClick: _propTypes.default.func,

  /** ListItemMeeting Popover Content */
  popoverContent: _propTypes.default.node,

  /** Time Object */
  time: _propTypes.default.shape({
    start: _propTypes.default.string,
    end: _propTypes.default.string
  }),

  /** ListItem title */
  title: _propTypes.default.string
};
/**
* @name List Item Meeting
*
* @category containers
* @component list-item
* @section list-item-meeting
*
* @js
*
import { Avatar, List, ListItemMeeting, ListItemHeader, Icon } from '@collab-ui/react';

export default class SpaceListExamples extends React.PureComponent {

  render() {
    return(
      <div style={{ width: '840px' }}>
        <List>
          <ListItemMeeting 
            isAllDay
            header='ListItemMeeting (isAllDay)'
            anchorLabel='SpaceString'
            anchorOnClick={() => console.log('anchor clicked')}
            childrenRight={<Avatar title='NA'/>} popoverContent={'test'}
          />
          <ListItemMeeting
            time={{start: '5:00PM', end: '10:00PM'}}
            header='ListItemMeeting (time object)'
            anchorLabel='SpaceString'
            anchorOnClick={() => console.log('anchor clicked')}
            childrenRight={<Avatar title='NA'/>} popoverContent={'test'}
          />
          <ListItemMeeting
            time={{start: '5:00PM', end: '10:00PM'}}
            inProgress
            header='ListItemMeeting (inProgress)'
            anchorLabel='SpaceString'
            anchorOnClick={() => console.log('anchor clicked')}
            childrenRight={<Avatar title='NA'/>}
            popoverContent={'test'}
          />
          <ListItemMeeting
            time={{start: '5:00PM', end: '10:00PM'}}
            isRecurring
            header='ListItemMeeting (isRecurring)'
            anchorLabel='SpaceString'
            anchorOnClick={() => console.log('anchor clicked')}
            childrenRight={<Avatar title='NA'/>}
            popoverContent={'test'}
          />
          <ListItemMeeting 
            time={{start: '5:00PM', end: '10:00PM'}}
            isRecurring
            isCompleted
            header='ListItemMeeting (isCompleted)'
            anchorLabel='SpaceString'
            anchorOnClick={() => console.log('anchor clicked')}
            childrenRight={<Avatar title='NA'/>} popoverContent={'test'}
          />
        </List>
      </div>
    );
  }
}
**/