"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ = require("./..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var MenuItem =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuItem, _React$Component);

  function MenuItem() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      anchorRef: null
    }, _this.handleKeyDown = function (e) {
      var handleKeyDown = _this.context.handleKeyDown;
      var index = _this.props.index;
      handleKeyDown && handleKeyDown(index, _assertThisInitialized(_assertThisInitialized(_this)), e);
    }, _this.handleClick = function (e) {
      var handleClick = _this.context.handleClick;
      var index = _this.props.index;
      handleClick && handleClick(index, _assertThisInitialized(_assertThisInitialized(_this)), e);
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = MenuItem.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        ariaLabel = _this$props.ariaLabel,
        className = _this$props.className,
        disabled = _this$props.disabled,
        focus = _this$props.focus,
        isHeader = _this$props.isHeader,
        isOpen = _this$props.isOpen,
        selectedValue = _this$props.selectedValue,
        separator = _this$props.separator,
        subMenu = _this$props.subMenu,
        title = _this$props.title,
        value = _this$props.value;
    return _react.default.createElement("div", {
      className: 'cui-menu-item' + ("" + (className && " " + className || '')),
      "aria-expanded": isOpen,
      "aria-haspopup": !!subMenu
    }, _react.default.createElement(_.ListItem, {
      active: isOpen,
      disabled: disabled,
      focus: focus,
      focusOnLoad: true,
      isReadOnly: isHeader,
      onClick: this.handleClick,
      onKeyDown: this.handleKeyDown,
      ref: function ref(_ref) {
        return !_this2.state.anchorRef && _this2.setState({
          anchorRef: _ref
        });
      },
      role: "menuitem",
      separator: separator,
      title: title,
      value: value
    }, _react.default.createElement("div", {
      className: "cui-menu-item__content"
    }, this.props.children), _react.default.createElement("div", {
      className: "cui-menu-item__selected-value",
      title: selectedValue
    }, subMenu && selectedValue), _react.default.createElement("div", {
      className: "cui-menu-item__arrow"
    }, subMenu && _react.default.createElement(_.Icon, {
      name: "arrow-right_16"
    }))), isOpen ? _react.default.createElement(_.EventOverlay, {
      anchorNode: this.state.anchorRef,
      isOpen: isOpen,
      direction: "right-top",
      closeOnClick: false
    }, _react.default.createElement("div", {
      "aria-label": ariaLabel,
      role: "menu"
    }, subMenu)) : null);
  };

  return MenuItem;
}(_react.default.Component);

exports.default = MenuItem;
MenuItem.displayName = 'MenuItem';
MenuItem.contextTypes = {
  handleClick: _propTypes.default.func,
  handleKeyDown: _propTypes.default.func
};
MenuItem.propTypes = {
  ariaLabel: _propTypes.default.string,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  index: _propTypes.default.array,
  isHeader: _propTypes.default.bool,
  isOpen: _propTypes.default.bool,
  focus: _propTypes.default.bool,
  menuItem: _propTypes.default.array,
  selectedValue: _propTypes.default.string,
  separator: _propTypes.default.bool,
  shouldCloseMenu: _propTypes.default.bool,
  subMenu: _propTypes.default.array,
  title: _propTypes.default.string,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.object, _propTypes.default.array])
};
MenuItem.defaultProps = {
  ariaLabel: '',
  className: '',
  children: null,
  disabled: false,
  focus: false,
  isHeader: false,
  isOpen: false,
  selectedValue: '',
  separator: false,
  shouldCloseMenu: false,
  subMenu: null,
  title: '',
  value: ''
};